create table `tbGroupSecretPermission` ( 
	`PermissionID` LONG,
	`GroupID` LONG,
	`SecretID` LONG,
	`ConcurrencyID` TEXT(50),
	`GroupSecretPermissionId` AUTOINCREMENT, constraint `PK_GroupSecretPermission` primary key (`GroupSecretPermissionId`) ); 

GO

create table `tbGroup` ( 
	`GroupID` AUTOINCREMENT,
	`GroupName` TEXT(100),
	`Active` BIT,
	`Created` DATETIME,
	`ConcurrencyID` TEXT(50),
	`IsPersonal` BIT, constraint `PK_tbGroup` primary key (`GroupID`) ); 

GO

create table `tbConfiguration` ( 
	`ConfigurationId` LONG,
	`AllowRememberMe` BIT,
	`AllowAutoComplete` BIT,
	`MaxLoginFailures` LONG, 
	`SmtpServer` TEXT(200),
	`FromEmailAddress` TEXT(200),
	constraint `PK_Configuration` primary key (`ConfigurationId`) ); 

GO

create table `tbAuditSecret` ( 
	`AuditSecretId` AUTOINCREMENT,
	`SecretId` LONG,
	`UserId` LONG,
	`DateRecorded` DATETIME,
	`Action` TEXT(50),
	`Notes` TEXT(255), constraint `PK__tbAuditSecret__267ABA7A` primary key (`AuditSecretId`) ); 

GO

alter table `tbUserGroup` add constraint `tbUserGroupConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO

alter table `tbUser` add constraint `tbUserConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbSecretType` add constraint `tbSecretTypeConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbSecretItem` add constraint `tbSecretItemConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbSecretField` add constraint `tbSecretFieldConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbSecret` add constraint `tbSecretConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbLicense` add constraint `tbLicenseConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO

alter table `tbLicense` add constraint `tbLicenseLicenseKey_UNIQ` unique (
	`LicenseKey`); 

GO


alter table `tbGroupSecretPermission` add constraint `UNIQ_GroupSecretPermission` unique (
	`ConcurrencyID`); 

GO


alter table `tbGroup` add constraint `tbGroupConcurrency_UNIQ` unique (
	`ConcurrencyID`); 

GO


alter table `tbUserGroup`
	add constraint `FK_tbUserGroup_Group` foreign key (
		`GroupID`)
	 references `tbGroup` (
		`GroupID`); 

GO






alter table `tbUserGroup`
	add constraint `FK_tbUserGroup_User` foreign key (
		`UserID`)
	 references `tbUser` (
		`UserId`); 

GO







alter table `tbSecretItem`
	add constraint `FK_tbSecretItem_tbSecret` foreign key (
		`SecretID`)
	 references `tbSecret` (
		`SecretID`); 

GO






alter table `tbSecretItem`
	add constraint `FK_tbSecretItem_tbSecretField` foreign key (
		`SecretFieldID`)
	 references `tbSecretField` (
		`SecretFieldID`); 

GO


alter table `tbSecretField`
	add constraint `FK_tbSecretField_tbSecretType` foreign key (
		`SecretTypeID`)
	 references `tbSecretType` (
		`SecretTypeID`); 

GO







alter table `tbSecret`
	add constraint `FK_tbSecret_tbSecretType` foreign key (
		`SecretTypeID`)
	 references `tbSecretType` (
		`SecretTypeID`); 

GO







alter table `tbGroupSecretPermission`
	add constraint `FK_tbPermission_Group` foreign key (
		`GroupID`)
	 references `tbGroup` (
		`GroupID`); 

GO






alter table `tbGroupSecretPermission`
	add constraint `FK_GroupSecretPermission_PermissionID` foreign key (
		`PermissionID`)
	 references `tbPermission` (
		`PermissionId`); 

GO

alter table `tbGroupSecretPermission`
	add constraint `FK_tbPermission_Secret` foreign key (
		`SecretID`)
	 references `tbSecret` (
		`SecretID`); 

GO







alter table `tbAuditSecret`
	add constraint `FK__tbAuditSe__Secre__276EDEB3` foreign key (
		`SecretId`)
	 references `tbSecret` (
		`SecretID`); 

GO

alter table `tbAuditSecret`
	add constraint `FK__tbAuditSe__UserI__286302EC` foreign key (
		`UserId`)
	 references `tbUser` (
		`UserId`); 



