if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbSecretType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbSecretType] (
		[SecretTypeID] [int] IDENTITY(1, 1) NOT NULL ,
		[SecretTypeName] [varchar] (150) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbSecretTypeConcurrency_UNIQ unique
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbSecretType] WITH NOCHECK ADD 
		CONSTRAINT [PK_tbSecretType] PRIMARY KEY  CLUSTERED 
		(
			[SecretTypeID]
		)  ON [PRIMARY] 
END
 
if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbSecret]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbSecret] (
		[SecretID] [int] IDENTITY(1, 1) NOT NULL ,
		[SecretName] [varchar] (128) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[Created] [datetime] NOT NULL ,
		[SecretTypeID] [int] NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbSecretConcurrency_UNIQ unique
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbSecret] ADD 
		CONSTRAINT [FK_tbSecret_tbSecretType] FOREIGN KEY 
		(
			[SecretTypeID]
		) REFERENCES [dbo].[tbSecretType] (
			[SecretTypeID]
		) ON UPDATE CASCADE 
	ALTER TABLE [dbo].[tbSecret] WITH NOCHECK ADD 
		CONSTRAINT [PK_tbSecret] PRIMARY KEY  CLUSTERED 
		(
			[SecretID]
		)  ON [PRIMARY] 
END

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbSecretField]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbSecretField] (
		[SecretFieldID] [int] IDENTITY(1, 1) NOT NULL ,
		[SecretFieldName] [varchar] (150) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[SecretFieldDisplayName] [varchar] (500) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[SortOrder] [int] NOT NULL ,
		[SecretTypeID] [int] NOT NULL ,
		[Required] [bit] NULL ,
		[DataType] [varchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbSecretFieldConcurrency_UNIQ unique
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbSecretField] ADD 
		CONSTRAINT [FK_tbSecretField_tbSecretType] FOREIGN KEY 
		(
			[SecretTypeID]
		) REFERENCES [dbo].[tbSecretType] (
			[SecretTypeID]
		) ON UPDATE CASCADE 
	ALTER TABLE [dbo].[tbSecretField] WITH NOCHECK ADD 
		CONSTRAINT [PK_tbSecretField] PRIMARY KEY  CLUSTERED 
		(
			[SecretFieldID]
		)  ON [PRIMARY] 
END


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbSecretItem]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[tbSecretItem] (
		[SecretItemID] [int] IDENTITY(1, 1) NOT NULL,
		[SecretID] [int] NOT NULL ,
		[SecretFieldID] [int] NOT NULL ,
		[ItemValue] [varchar] (4000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
		[ConcurrencyID] [varchar] (50) NOT NULL constraint tbSecretItemConcurrency_UNIQ unique
	) ON [PRIMARY]
	ALTER TABLE [dbo].[tbSecretItem] ADD 
		CONSTRAINT [FK_tbSecretItem_tbSecret] FOREIGN KEY 
		(
			[SecretID]
		) REFERENCES [dbo].[tbSecret] (
			[SecretID]
		) ON DELETE CASCADE  ON UPDATE CASCADE ,
		CONSTRAINT [FK_tbSecretItem_tbSecretField] FOREIGN KEY 
		(
			[SecretFieldID]
		) REFERENCES [dbo].[tbSecretField] (
			[SecretFieldID]
		)
	ALTER TABLE [dbo].[tbSecretItem] WITH NOCHECK ADD 
		CONSTRAINT [PK_tbSecretItem] PRIMARY KEY  CLUSTERED 
		(
			[SecretItemID]
		)  ON [PRIMARY] 
END