INSERT INTO [dbo].tbPasswordType
(
	 [Name]
	,[TypeName]
)
SELECT 'SQL Server Account', 'Thycotic.ihawu.Business.Federator.SqlAccountFederator' UNION
SELECT 'Windows Account', 'Thycotic.ihawu.Business.Federator.WindowsAccountFederator' UNION
SELECT 'Active Directory Account', 'Thycotic.ihawu.Business.Federator.WindowsAccountFederator'

GO

INSERT INTO [dbo].tbPasswordTypeField
(
	 [Name]
	,[PasswordTypeId]
)
SELECT 'Server', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'SQL Server Account' UNION
SELECT 'Username', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'SQL Server Account' UNION
SELECT 'Password', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'SQL Server Account' UNION

SELECT 'Machine', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Windows Account' UNION
SELECT 'Username', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Windows Account' UNION
SELECT 'Password', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Windows Account' UNION

SELECT 'Domain', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Active Directory Account' UNION
SELECT 'Username', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Active Directory Account' UNION
SELECT 'Password', PasswordTypeId FROM [dbo].tbPasswordType WHERE [dbo].tbPasswordType.Name = 'Active Directory Account'

GO

INSERT INTO [dbo].tbSecretType
(
	 [SecretTypeName]
	,[ConcurrencyId]
	,[Active]
	,[SecretTypeDescription]
	,[OrganizationId]
	,[NamePattern]
	,[NamePatternErrorMessage]
	,[ExpirationDays]
	,[ExpirationFieldId]
	,[PasswordTypeId]
	,[PasswordTypeReady]
	,[SecretNameHistoryLength]
)
SELECT '*NEW* SQL Server Account',       NEWID(), 1, '', 1, NULL, NULL, 30, NULL, PasswordTypeId, 1, 0 FROM [dbo].tbPasswordType WHERE [Name] = 'SQL Server Account' UNION
SELECT '*NEW* Windows Account',          NEWID(), 1, '', 1, NULL, NULL, 30, NULL, PasswordTypeId, 1, 0 FROM [dbo].tbPasswordType WHERE [Name] = 'Windows Account' UNION
SELECT '*NEW* Active Directory Account', NEWID(), 1, '', 1, NULL, NULL, 30, NULL, PasswordTypeId, 1, 0 FROM [dbo].tbPasswordType WHERE [Name] = 'Active Directory Account'

GO

INSERT INTO [dbo].tbSecretField
(
	 [SecretFieldName]
	,[SecretFieldDisplayName]
	,[SortOrder]
	,[SecretTypeId]
	,[Required]
	,[DataType]
	,[ConcurrencyId]
	,[MustEncrypt]
	,[IsPassword]
	,[IsUrl]
	,[IsNotes]
	,[SecretFieldDescription]
	,[GeneratePasswordLength]
	,[GeneratePasswordCharacterSet]
	,[HistoryLength]
	,[PasswordTypeFieldId]
)
SELECT 'Server', 'Server', 1, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The Server or Location of the SQL Server.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'
AND
[dbo].tbPasswordType.Name = 'SQL Server Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Server'

UNION

SELECT 'Username', 'Username', 2, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The SQL Server Username.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'
AND
[dbo].tbPasswordType.Name = 'SQL Server Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Username'

UNION

SELECT 'Password', 'Password', 3, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 1, 0, 0, 'The password of the SQL Server Account.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'
AND
[dbo].tbPasswordType.Name = 'SQL Server Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Password'

UNION

SELECT 'Notes', 'Notes', 4, [dbo].tbSecretType.SecretTypeId, 0, 'string', NEWID(), 1, 0, 0, 1, 'Any additional notes.', 12, NULL, 0, NULL
FROM
[dbo].tbSecretType WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'

GO

INSERT INTO [dbo].tbSecretField
(
	 [SecretFieldName]
	,[SecretFieldDisplayName]
	,[SortOrder]
	,[SecretTypeId]
	,[Required]
	,[DataType]
	,[ConcurrencyId]
	,[MustEncrypt]
	,[IsPassword]
	,[IsUrl]
	,[IsNotes]
	,[SecretFieldDescription]
	,[GeneratePasswordLength]
	,[GeneratePasswordCharacterSet]
	,[HistoryLength]
	,[PasswordTypeFieldId]
)
SELECT 'Machine', 'Machine', 1, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The Server or Location of the SQL Server.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'
AND
[dbo].tbPasswordType.Name = 'Windows Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Machine'

UNION

SELECT 'Username', 'Username', 2, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The SQL Server Username.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'
AND
[dbo].tbPasswordType.Name = 'Windows Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Username'

UNION

SELECT 'Password', 'Password', 3, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 1, 0, 0, 'The password of the SQL Server Account.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'
AND
[dbo].tbPasswordType.Name = 'Windows Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Password'

UNION

SELECT 'Notes', 'Notes', 4, [dbo].tbSecretType.SecretTypeId, 0, 'string', NEWID(), 1, 0, 0, 1, 'Any additional notes.', 12, NULL, 0, NULL
FROM
[dbo].tbSecretType WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'

GO

INSERT INTO [dbo].tbSecretField
(
	 [SecretFieldName]
	,[SecretFieldDisplayName]
	,[SortOrder]
	,[SecretTypeId]
	,[Required]
	,[DataType]
	,[ConcurrencyId]
	,[MustEncrypt]
	,[IsPassword]
	,[IsUrl]
	,[IsNotes]
	,[SecretFieldDescription]
	,[GeneratePasswordLength]
	,[GeneratePasswordCharacterSet]
	,[HistoryLength]
	,[PasswordTypeFieldId]
)
SELECT 'Domain', 'Domain', 1, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The Server or Location of the SQL Server.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'
AND
[dbo].tbPasswordType.Name = 'Active Directory Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Domain'

UNION

SELECT 'Username', 'Username', 2, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 0, 0, 0, 'The SQL Server Username.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'
AND
[dbo].tbPasswordType.Name = 'Active Directory Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Username'

UNION

SELECT 'Password', 'Password', 3, [dbo].tbSecretType.SecretTypeId, 1, 'string', NEWID(), 1, 1, 0, 0, 'The password of the SQL Server Account.', 12, NULL, 0, [dbo].tbPasswordTypeField.PasswordTypeFieldId
FROM [dbo].tbSecretType, [dbo].tbPasswordType, [dbo].tbPasswordTypeField WHERE
[dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'
AND
[dbo].tbPasswordType.Name = 'Active Directory Account'
AND
[dbo].tbPasswordType.PasswordTypeId = [dbo].tbPasswordTypeField.PasswordTypeId
AND
[dbo].tbPasswordTypeField.[Name] = 'Password'

UNION

SELECT 'Notes', 'Notes', 4, [dbo].tbSecretType.SecretTypeId, 0, 'string', NEWID(), 1, 0, 0, 1, 'Any additional notes.', 12, NULL, 0, NULL
FROM
[dbo].tbSecretType WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'

GO

UPDATE [dbo].tbSecretType SET ExpirationFieldId = (

	SELECT [dbo].tbSecretField.SecretFieldId FROM [dbo].tbSecretField, [dbo].tbSecretType
	WHERE [dbo].tbSecretField.SecretFieldName = 'Password'
	AND
	[dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'
	AND
	[dbo].tbSecretField.SecretTypeId = [dbo].tbSecretType.SecretTypeId
	)
WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* SQL Server Account'

GO

UPDATE [dbo].tbSecretType SET ExpirationFieldId = (

	SELECT [dbo].tbSecretField.SecretFieldId FROM [dbo].tbSecretField, [dbo].tbSecretType
	WHERE [dbo].tbSecretField.SecretFieldName = 'Password'
	AND
	[dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'
	AND
	[dbo].tbSecretField.SecretTypeId = [dbo].tbSecretType.SecretTypeId
	)
WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* Windows Account'

GO

UPDATE [dbo].tbSecretType SET ExpirationFieldId = (

	SELECT [dbo].tbSecretField.SecretFieldId FROM [dbo].tbSecretField, [dbo].tbSecretType
	WHERE [dbo].tbSecretField.SecretFieldName = 'Password'
	AND
	[dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'
	AND
	[dbo].tbSecretField.SecretTypeId = [dbo].tbSecretType.SecretTypeId
	)
WHERE [dbo].tbSecretType.SecretTypeName = '*NEW* Active Directory Account'