<%@ Page language="c#" Codebehind="IPAddressEdit.aspx.cs" AutoEventWireup="false" Inherits="Thycotic.ihawu.Web.IPAddressEdit" %>
<%@ Register TagPrefix="ihawu" Namespace="Thycotic.ihawu.Web" Assembly="Thycotic.ihawu.Web" %>
<%@ Register TagPrefix="thycotic" Namespace="Thycotic.Foundation.WebControls" Assembly="Thycotic.Foundation.WebControls" %>
<%@ Register TagPrefix="custom" Namespace="Thycotic.ihawu.Web.customcontrols" Assembly="Thycotic.ihawu.Web" %>
<ihawu:masterpage id="masterPage" runat="server">
	<custom:newdialog id="NewIPAddressDialog" Caption="Add New IP Address" runat="server" visible="true">
		<table>
			<tr>
				<td><thycotic:fieldlabel id="IPAddressNameLabel" runat="server" Text="IP Address User/Network Name" /></td>
				<td>&nbsp;</td>
				<td>
					<thycotic:textbox id="IPAddressNameTextBox" MaxLength="50" runat="server" />
					<thycotic:requiredfieldvalidator id="IPAddressNameTextBoxValidator" runat="server" controltovalidate="IPAddressNameTextBox" />
					<thycotic:BusinessValidator id="IPAddressNameExistsValidator" runat="server" errormessage="An IP Address with the same name already exists." controltovalidate="IPAddressNameTextBox" />	
				</td>
				<td></td>
			</tr>
			<tr>
				<td><thycotic:fieldlabel id="StartIPLabel" runat="server" Text="Start IP Address" /></td>
				<td>&nbsp;</td>
				<td>
					<thycotic:textbox id="StartIPTextBox" MaxLength="15" runat="server" onkeypress="return numbersOrPeriod(event)" onkeyup="copyContent()" />
					<thycotic:requiredfieldvalidator id="StartIPRequiredValidator" runat="server" errormessage="Please enter a start IP Address." controltovalidate="StartIPTextBox" />
					<thycotic:RegularExpressionValidator id="StartIPRegexValidator" runat="server" errormessage="Please enter a valid start IP Address." controltovalidate="StartIPTextBox" ValidationExpression="\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b" />		
				</td>
				<td></td>
			</tr>
			<tr>
				<td><thycotic:fieldlabel id="EndIPLabel" runat="server" Text="End IP Address" /></td>
				<td>&nbsp;</td>
				<td>
					<thycotic:textbox id="EndIPTextBox" MaxLength="15" runat="server" onkeypress="return numbersOrPeriod(event)" />
					<thycotic:requiredfieldvalidator id="EndIPRequiredValidator" runat="server" errormessage="Please enter an end IP Address." controltovalidate="EndIPTextBox" />
					<thycotic:RegularExpressionValidator id="EndIPRegexValidator" runat="server" errormessage="Please enter a valid end IP Address." controltovalidate="EndIPTextBox" ValidationExpression="\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b" />		
				</td>
				<td></td>
			</tr>			
			<tr>
				<td colSpan="4">
					<br />
					<thycotic:BusinessValidator id="IPAddressRangeValidator" runat="server" />	
					<thycotic:button id="SaveButton" runat="server" text="Save" />
					<thycotic:button id="CancelButton" runat="server" text="Cancel" />
				</td>
			</tr>			
		</table>
		<script language="javascript">
		
			CopyContent("StartIPTextBox", "EndIPTextBox");
		}
		
		function numbersOrPeriod(e)
		{
			var keynum;
			var keychar;
			var numcheck;
			if (e.keyCode == 8 || e.keyCode == 46 || 
				e.keyCode == 37 || e.keyCode == 39)
			{
				return true;
			}
			
		function copyContent()
		{
			if(window.event) // IE
			{
				keynum = e.keyCode;
			}
			else if(e.which) // Netscape/Firefox/Opera
			{
				keynum = e.which;
			}
			
			keychar = String.fromCharCode(keynum);
			numcheck = /(\d|\.)/;
			return numcheck.test(keychar);
		}
		</script>
	</custom:newdialog>
</ihawu:masterpage>
